import { BuilderContext } from '@angular-devkit/architect';
import { TransformProvider } from 'ng-packagr/lib/brocc/transform.di';
import { HookHandler, TypedTask, NgPackagerHooks, NgPackagrBuilderTaskOptions, NgPackagrBuilderTaskSchema, NormalizedNgPackagerHooks } from './hooks';
export declare const TRANSFORM_PROVIDER_MAP: Record<keyof NgPackagerHooks, TransformProvider>;
export declare const HOOK_PHASES: ("before" | "replace" | "after")[];
export declare function isTypedTask<T>(hook: TypedTask<T> | HookHandler<T>): hook is TypedTask<T>;
export declare function getHandler<T>(hook: TypedTask<T> | HookHandler<T>): HookHandler<T>;
export declare function normalizeHooks(hooks: NgPackagerHooks): NormalizedNgPackagerHooks;
export declare function getTaskDataInput<T>(task: TypedTask, tasks: NgPackagrBuilderTaskOptions<NgPackagrBuilderTaskSchema>): {
    [x: string]: any;
};
export declare function validateTypedTasks(hooks: NormalizedNgPackagerHooks, context: BuilderContext, tasks: NgPackagrBuilderTaskOptions<NgPackagrBuilderTaskSchema>): Promise<NormalizedNgPackagerHooks>;
//# sourceMappingURL=utils.d.ts.map